Index: ddp_usrreq.c
===================================================================
--- ddp_usrreq.c	(.../stable/4/sys/netatalk)	(revision 196046)
+++ ddp_usrreq.c	(.../head/sys/netatalk)	(revision 196046)
@@ -1,11 +1,57 @@
-/*
- * Copyright (c) 1990,1994 Regents of The University of Michigan.
- * All Rights Reserved.  See COPYRIGHT.
+/*-
+ * Copyright (c) 2004-2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * Copyright (c) 1990, 1994 Regents of The University of Michigan.
+ * All Rights Reserved.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby granted,
+ * provided that the above copyright notice appears in all copies and
+ * that both that copyright notice and this permission notice appear
+ * in supporting documentation, and that the name of The University
+ * of Michigan not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior
+ * permission. This software is supplied as is without expressed or
+ * implied warranties of any kind.
+ *
+ * This product includes software developed by the University of
+ * California, Berkeley and its contributors.
+ *
+ *	Research Systems Unix Group
+ *	The University of Michigan
+ *	c/o Wesley Craig
+ *	535 W. William Street
+ *	Ann Arbor, Michigan
+ *	+1-313-764-2278
+ *	netatalk@umich.edu
+ *
+ * $FreeBSD$
  */
 
 #include <sys/param.h>
 #include <sys/systm.h>
-#include <sys/proc.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
@@ -13,573 +59,273 @@
 #include <sys/protosw.h>
 #include <net/if.h>
 #include <net/route.h>
+#include <net/netisr.h>
 
 #include <netatalk/at.h>
 #include <netatalk/at_var.h>
 #include <netatalk/ddp_var.h>
+#include <netatalk/ddp_pcb.h>
 #include <netatalk/at_extern.h>
 
-static void at_pcbdisconnect( struct ddpcb *ddp );
-static void at_sockaddr(struct ddpcb *ddp, struct sockaddr **addr);
-static int at_pcbsetaddr(struct ddpcb *ddp, struct sockaddr *addr,
-			  struct proc *p);
-static int at_pcbconnect(struct ddpcb *ddp, struct sockaddr *addr, 
-			 struct proc *p);
-static void at_pcbdetach(struct socket *so, struct ddpcb *ddp);
-static int at_pcballoc(struct socket *so);
-
-struct ddpcb	*ddp_ports[ ATPORT_LAST ];
-struct ddpcb	*ddpcb = NULL;
 static u_long	ddp_sendspace = DDP_MAXSZ; /* Max ddp size + 1 (ddp_type) */
-static u_long	ddp_recvspace = 10 * ( 587 + sizeof( struct sockaddr_at ));
+static u_long	ddp_recvspace = 10 * (587 + sizeof(struct sockaddr_at));
 
+static const struct netisr_handler atalk1_nh = {
+	.nh_name = "atalk1",
+	.nh_handler = at1intr,
+	.nh_proto = NETISR_ATALK1,
+	.nh_policy = NETISR_POLICY_SOURCE,
+};
 
+static const struct netisr_handler atalk2_nh = {
+	.nh_name = "atalk2",
+	.nh_handler = at2intr,
+	.nh_proto = NETISR_ATALK2,
+	.nh_policy = NETISR_POLICY_SOURCE,
+};
+
+static const struct netisr_handler aarp_nh = {
+	.nh_name = "aarp",
+	.nh_handler = aarpintr,
+	.nh_proto = NETISR_AARP,
+	.nh_policy = NETISR_POLICY_SOURCE,
+};
+
 static int
-ddp_attach(struct socket *so, int proto, struct proc *p)
+ddp_attach(struct socket *so, int proto, struct thread *td)
 {
-	struct ddpcb	*ddp;
-	int		error = 0;
-	int		s;
+	int error = 0;
 	
+	KASSERT(sotoddpcb(so) == NULL, ("ddp_attach: ddp != NULL"));
 
-	ddp = sotoddpcb( so );
-	if ( ddp != NULL ) {
-	    return( EINVAL);
-	}
+	/*
+	 * Allocate socket buffer space first so that it's present
+	 * before first use.
+	 */
+	error = soreserve(so, ddp_sendspace, ddp_recvspace);
+	if (error)
+		return (error);
 
-	s = splnet();
-	error = at_pcballoc( so );
-	splx(s);
-	if (error) {
-	    return (error);
-	}
-	return (soreserve( so, ddp_sendspace, ddp_recvspace ));
+	DDP_LIST_XLOCK();
+	error = at_pcballoc(so);
+	DDP_LIST_XUNLOCK();
+	return (error);
 }
 
-static int
+static void
 ddp_detach(struct socket *so)
 {
-	struct ddpcb	*ddp;
-	int		s;
+	struct ddpcb *ddp;
 	
-	ddp = sotoddpcb( so );
-	if ( ddp == NULL ) {
-	    return( EINVAL);
-	}
-	s = splnet();
-	at_pcbdetach( so, ddp );
-	splx(s);
-	return(0);
+	ddp = sotoddpcb(so);
+	KASSERT(ddp != NULL, ("ddp_detach: ddp == NULL"));
+
+	DDP_LIST_XLOCK();
+	DDP_LOCK(ddp);
+	at_pcbdetach(so, ddp);
+	DDP_LIST_XUNLOCK();
 }
 
 static int      
-ddp_bind(struct socket *so, struct sockaddr *nam, struct proc *p)
+ddp_bind(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	struct ddpcb	*ddp;
-	int		error = 0;
-	int		s;
+	struct ddpcb *ddp;
+	int error = 0;
 	
-	ddp = sotoddpcb( so );
-	if ( ddp == NULL ) {
-	    return( EINVAL);
-	}
-	s = splnet();
-	error = at_pcbsetaddr(ddp, nam, p);
-	splx(s);
+	ddp = sotoddpcb(so);
+	KASSERT(ddp != NULL, ("ddp_bind: ddp == NULL"));
+
+	DDP_LIST_XLOCK();
+	DDP_LOCK(ddp);
+	error = at_pcbsetaddr(ddp, nam, td);
+	DDP_UNLOCK(ddp);
+	DDP_LIST_XUNLOCK();
 	return (error);
 }
     
 static int
-ddp_connect(struct socket *so, struct sockaddr *nam, struct proc *p)
+ddp_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	struct ddpcb	*ddp;
-	int		error = 0;
-	int		s;
+	struct ddpcb *ddp;
+	int error = 0;
 	
-	ddp = sotoddpcb( so );
-	if ( ddp == NULL ) {
-	    return( EINVAL);
-	}
+	ddp = sotoddpcb(so);
+	KASSERT(ddp != NULL, ("ddp_connect: ddp == NULL"));
 
-	if ( ddp->ddp_fsat.sat_port != ATADDR_ANYPORT ) {
-	    return(EISCONN);
+	DDP_LIST_XLOCK();
+	DDP_LOCK(ddp);
+	if (ddp->ddp_fsat.sat_port != ATADDR_ANYPORT) {
+		DDP_UNLOCK(ddp);
+		DDP_LIST_XUNLOCK();
+		return (EISCONN);
 	}
 
-	s = splnet();
-	error = at_pcbconnect( ddp, nam, p );
-	splx(s);
-	if ( error == 0 )
-	    soisconnected( so );
-	return(error);
+	error = at_pcbconnect( ddp, nam, td );
+	DDP_UNLOCK(ddp);
+	DDP_LIST_XUNLOCK();
+	if (error == 0)
+		soisconnected(so);
+	return (error);
 }
 
 static int
 ddp_disconnect(struct socket *so)
 {
-
-	struct ddpcb	*ddp;
-	int		s;
+	struct ddpcb *ddp;
 	
-	ddp = sotoddpcb( so );
-	if ( ddp == NULL ) {
-	    return( EINVAL);
+	ddp = sotoddpcb(so);
+	KASSERT(ddp != NULL, ("ddp_disconnect: ddp == NULL"));
+
+	DDP_LOCK(ddp);
+	if (ddp->ddp_fsat.sat_addr.s_node == ATADDR_ANYNODE) {
+		DDP_UNLOCK(ddp);
+		return (ENOTCONN);
 	}
-	if ( ddp->ddp_fsat.sat_addr.s_node == ATADDR_ANYNODE ) {
-	    return(ENOTCONN);
-	}
 
-	s = splnet();
-	at_pcbdisconnect( ddp );
+	at_pcbdisconnect(ddp);
 	ddp->ddp_fsat.sat_addr.s_node = ATADDR_ANYNODE;
-	splx(s);
-	soisdisconnected( so );
-	return(0);
+	DDP_UNLOCK(ddp);
+	soisdisconnected(so);
+	return (0);
 }
 
 static int
 ddp_shutdown(struct socket *so)
 {
-	struct ddpcb	*ddp;
 
-	ddp = sotoddpcb( so );
-	if ( ddp == NULL ) {
-		return( EINVAL);
-	}
-	socantsendmore( so );
-	return(0);
+	KASSERT(sotoddpcb(so) != NULL, ("ddp_shutdown: ddp == NULL"));
+
+	socantsendmore(so);
+	return (0);
 }
 
 static int
 ddp_send(struct socket *so, int flags, struct mbuf *m, struct sockaddr *addr,
-            struct mbuf *control, struct proc *p)
+    struct mbuf *control, struct thread *td)
 {
-	struct ddpcb	*ddp;
-	int		error = 0;
-	int		s;
+	struct ddpcb *ddp;
+	int error = 0;
 	
-	ddp = sotoddpcb( so );
-	if ( ddp == NULL ) {
-		return(EINVAL);
-	}
+	ddp = sotoddpcb(so);
+	KASSERT(ddp != NULL, ("ddp_send: ddp == NULL"));
 
-    	if ( control && control->m_len ) {
-		return(EINVAL);
-    	}
+    	if (control && control->m_len)
+		return (EINVAL);
 
-	if ( addr ) {
-		if ( ddp->ddp_fsat.sat_port != ATADDR_ANYPORT ) {
-			return(EISCONN);
+	if (addr != NULL) {
+		DDP_LIST_XLOCK();
+		DDP_LOCK(ddp);
+		if (ddp->ddp_fsat.sat_port != ATADDR_ANYPORT) {
+			error = EISCONN;
+			goto out;
 		}
 
-		s = splnet();
-		error = at_pcbconnect(ddp, addr, p);
-		splx( s );
-		if ( error ) {
-			return(error);
+		error = at_pcbconnect(ddp, addr, td);
+		if (error == 0) {
+			error = ddp_output(m, so);
+			at_pcbdisconnect(ddp);
 		}
+out:
+		DDP_UNLOCK(ddp);
+		DDP_LIST_XUNLOCK();
 	} else {
-		if ( ddp->ddp_fsat.sat_port == ATADDR_ANYPORT ) {
-			return(ENOTCONN);
-		}
+		DDP_LOCK(ddp);
+		if (ddp->ddp_fsat.sat_port == ATADDR_ANYPORT)
+			error = ENOTCONN;
+		else
+			error = ddp_output(m, so);
+		DDP_UNLOCK(ddp);
 	}
-
-	s = splnet();
-	error = ddp_output( m, so );
-	if ( addr ) {
-	    at_pcbdisconnect( ddp );
-	}
-	splx(s);
-	return(error);
+	return (error);
 }
 
-static int
+/*
+ * XXXRW: This is never called because we only invoke abort on stream
+ * protocols.
+ */
+static void
 ddp_abort(struct socket *so)
 {
 	struct ddpcb	*ddp;
-	int		s;
 	
-	ddp = sotoddpcb( so );
-	if ( ddp == NULL ) {
-		return(EINVAL);
-	}
-	soisdisconnected( so );
-	s = splnet();
-	at_pcbdetach( so, ddp );
-	splx(s);
-	return(0);
+	ddp = sotoddpcb(so);
+	KASSERT(ddp != NULL, ("ddp_abort: ddp == NULL"));
+
+	DDP_LOCK(ddp);
+	at_pcbdisconnect(ddp);
+	DDP_UNLOCK(ddp);
+	soisdisconnected(so);
 }
 
-
 static void
-at_sockaddr(struct ddpcb *ddp, struct sockaddr **addr)
+ddp_close(struct socket *so)
 {
-    *addr = dup_sockaddr((struct sockaddr *)&ddp->ddp_lsat, 0);
-}
+	struct ddpcb	*ddp;
+	
+	ddp = sotoddpcb(so);
+	KASSERT(ddp != NULL, ("ddp_close: ddp == NULL"));
 
-static int 
-at_pcbsetaddr(struct ddpcb *ddp, struct sockaddr *addr, struct proc *p)
-{
-    struct sockaddr_at	lsat, *sat;
-    struct at_ifaddr	*aa;
-    struct ddpcb	*ddpp;
-
-    if ( ddp->ddp_lsat.sat_port != ATADDR_ANYPORT ) { /* shouldn't be bound */
-	return( EINVAL );
-    }
-
-    if (addr != 0) {			/* validate passed address */
-	sat = (struct sockaddr_at *)addr;
-	if (sat->sat_family != AF_APPLETALK) {
-	    return(EAFNOSUPPORT);
-	}
-
-	if ( sat->sat_addr.s_node != ATADDR_ANYNODE ||
-		sat->sat_addr.s_net != ATADDR_ANYNET ) {
-	    for ( aa = at_ifaddr; aa; aa = aa->aa_next ) {
-		if (( sat->sat_addr.s_net == AA_SAT( aa )->sat_addr.s_net ) &&
-		 ( sat->sat_addr.s_node == AA_SAT( aa )->sat_addr.s_node )) {
-		    break;
-		}
-	    }
-	    if ( !aa ) {
-		return( EADDRNOTAVAIL );
-	    }
-	}
-
-	if ( sat->sat_port != ATADDR_ANYPORT ) {
-	    if ( sat->sat_port < ATPORT_FIRST ||
-		    sat->sat_port >= ATPORT_LAST ) {
-		return( EINVAL );
-	    }
-	    if ( sat->sat_port < ATPORT_RESERVED &&
-		 suser(p) ) {
-		return( EACCES );
-	    }
-	}
-    } else {
-	bzero( (caddr_t)&lsat, sizeof( struct sockaddr_at ));
-	lsat.sat_len = sizeof(struct sockaddr_at);
-	lsat.sat_addr.s_node = ATADDR_ANYNODE;
-	lsat.sat_addr.s_net = ATADDR_ANYNET;
-	lsat.sat_family = AF_APPLETALK;
-	sat = &lsat;
-    }
-
-    if ( sat->sat_addr.s_node == ATADDR_ANYNODE &&
-	    sat->sat_addr.s_net == ATADDR_ANYNET ) {
-	if ( at_ifaddr == NULL ) {
-	    return( EADDRNOTAVAIL );
-	}
-	sat->sat_addr = AA_SAT( at_ifaddr )->sat_addr;
-    }
-    ddp->ddp_lsat = *sat;
-
-    /*
-     * Choose port.
-     */
-    if ( sat->sat_port == ATADDR_ANYPORT ) {
-	for ( sat->sat_port = ATPORT_RESERVED;
-		sat->sat_port < ATPORT_LAST; sat->sat_port++ ) {
-	    if ( ddp_ports[ sat->sat_port - 1 ] == 0 ) {
-		break;
-	    }
-	}
-	if ( sat->sat_port == ATPORT_LAST ) {
-	    return( EADDRNOTAVAIL );
-	}
-	ddp->ddp_lsat.sat_port = sat->sat_port;
-	ddp_ports[ sat->sat_port - 1 ] = ddp;
-    } else {
-	for ( ddpp = ddp_ports[ sat->sat_port - 1 ]; ddpp;
-		ddpp = ddpp->ddp_pnext ) {
-	    if ( ddpp->ddp_lsat.sat_addr.s_net == sat->sat_addr.s_net &&
-		    ddpp->ddp_lsat.sat_addr.s_node == sat->sat_addr.s_node ) {
-		break;
-	    }
-	}
-	if ( ddpp != NULL ) {
-	    return( EADDRINUSE );
-	}
-	ddp->ddp_pnext = ddp_ports[ sat->sat_port - 1 ];
-	ddp_ports[ sat->sat_port - 1 ] = ddp;
-	if ( ddp->ddp_pnext ) {
-	    ddp->ddp_pnext->ddp_pprev = ddp;
-	}
-    }
-
-    return( 0 );
+	DDP_LOCK(ddp);
+	at_pcbdisconnect(ddp);
+	DDP_UNLOCK(ddp);
+	soisdisconnected(so);
 }
 
-static int
-at_pcbconnect(struct ddpcb *ddp, struct sockaddr *addr, struct proc *p)
+void 
+ddp_init(void)
 {
-    struct sockaddr_at	*sat = (struct sockaddr_at *)addr;
-    struct route	*ro;
-    struct at_ifaddr	*aa = 0;
-    struct ifnet	*ifp;
-    u_short		hintnet = 0, net;
 
-    if (sat->sat_family != AF_APPLETALK) {
-	return(EAFNOSUPPORT);
-    }
-
-    /*
-     * Under phase 2, network 0 means "the network".  We take "the
-     * network" to mean the network the control block is bound to.
-     * If the control block is not bound, there is an error.
-     */
-    if ( sat->sat_addr.s_net == ATADDR_ANYNET
-		&& sat->sat_addr.s_node != ATADDR_ANYNODE ) {
-	if ( ddp->ddp_lsat.sat_port == ATADDR_ANYPORT ) {
-	    return( EADDRNOTAVAIL );
-	}
-	hintnet = ddp->ddp_lsat.sat_addr.s_net;
-    }
-
-    ro = &ddp->ddp_route;
-    /*
-     * If we've got an old route for this pcb, check that it is valid.
-     * If we've changed our address, we may have an old "good looking"
-     * route here.  Attempt to detect it.
-     */
-    if ( ro->ro_rt ) {
-	if ( hintnet ) {
-	    net = hintnet;
-	} else {
-	    net = sat->sat_addr.s_net;
-	}
-	aa = 0;
-	if ((ifp = ro->ro_rt->rt_ifp) != NULL) {
-	    for ( aa = at_ifaddr; aa; aa = aa->aa_next ) {
-		if ( aa->aa_ifp == ifp &&
-			ntohs( net ) >= ntohs( aa->aa_firstnet ) &&
-			ntohs( net ) <= ntohs( aa->aa_lastnet )) {
-		    break;
-		}
-	    }
-	}
-	if ( aa == NULL || ( satosat( &ro->ro_dst )->sat_addr.s_net !=
-		( hintnet ? hintnet : sat->sat_addr.s_net ) ||
-		satosat( &ro->ro_dst )->sat_addr.s_node !=
-		sat->sat_addr.s_node )) {
-	    RTFREE( ro->ro_rt );
-	    ro->ro_rt = (struct rtentry *)0;
-	}
-    }
-
-    /*
-     * If we've got no route for this interface, try to find one.
-     */
-    if ( ro->ro_rt == (struct rtentry *)0 ||
-	 ro->ro_rt->rt_ifp == (struct ifnet *)0 ) {
-	ro->ro_dst.sa_len = sizeof( struct sockaddr_at );
-	ro->ro_dst.sa_family = AF_APPLETALK;
-	if ( hintnet ) {
-	    satosat( &ro->ro_dst )->sat_addr.s_net = hintnet;
-	} else {
-	    satosat( &ro->ro_dst )->sat_addr.s_net = sat->sat_addr.s_net;
-	}
-	satosat( &ro->ro_dst )->sat_addr.s_node = sat->sat_addr.s_node;
-	rtalloc( ro );
-    }
-
-    /*
-     * Make sure any route that we have has a valid interface.
-     */
-    aa = 0;
-    if ( ro->ro_rt && ( ifp = ro->ro_rt->rt_ifp )) {
-	for ( aa = at_ifaddr; aa; aa = aa->aa_next ) {
-	    if ( aa->aa_ifp == ifp ) {
-		break;
-	    }
-	}
-    }
-    if ( aa == 0 ) {
-	return( ENETUNREACH );
-    }
-
-    ddp->ddp_fsat = *sat;
-    if ( ddp->ddp_lsat.sat_port == ATADDR_ANYPORT ) {
-	return(at_pcbsetaddr(ddp, (struct sockaddr *)0, p));
-    }
-    return( 0 );
+	DDP_LIST_LOCK_INIT();
+	TAILQ_INIT(&at_ifaddrhead);
+	netisr_register(&atalk1_nh);
+	netisr_register(&atalk2_nh);
+	netisr_register(&aarp_nh);
 }
 
+#if 0
 static void 
-at_pcbdisconnect( struct ddpcb	*ddp )
+ddp_clean(void)
 {
-    ddp->ddp_fsat.sat_addr.s_net = ATADDR_ANYNET;
-    ddp->ddp_fsat.sat_addr.s_node = ATADDR_ANYNODE;
-    ddp->ddp_fsat.sat_port = ATADDR_ANYPORT;
+	struct ddpcp	*ddp;
+
+	for (ddp = ddpcb_list; ddp != NULL; ddp = ddp->ddp_next)
+		at_pcbdetach(ddp->ddp_socket, ddp);
+	DDP_LIST_LOCK_DESTROY();
 }
+#endif
 
 static int
-at_pcballoc( struct socket *so )
+at_getpeeraddr(struct socket *so, struct sockaddr **nam)
 {
-	struct ddpcb	*ddp;
 
-	MALLOC(ddp, struct ddpcb *, sizeof *ddp, M_PCB, M_WAITOK);
-	bzero(ddp, sizeof *ddp);
-	ddp->ddp_lsat.sat_port = ATADDR_ANYPORT;
-
-	ddp->ddp_next = ddpcb;
-	ddp->ddp_prev = NULL;
-	ddp->ddp_pprev = NULL;
-	ddp->ddp_pnext = NULL;
-	if (ddpcb) {
-		ddpcb->ddp_prev = ddp;
-	}
-	ddpcb = ddp;
-
-	ddp->ddp_socket = so;
-	so->so_pcb = (caddr_t)ddp;
-	return(0);
+	return (EOPNOTSUPP);
 }
 
-static void
-at_pcbdetach( struct socket *so, struct ddpcb *ddp)
-{
-    soisdisconnected( so );
-    so->so_pcb = 0;
-    sofree( so );
-
-    /* remove ddp from ddp_ports list */
-    if ( ddp->ddp_lsat.sat_port != ATADDR_ANYPORT &&
-	    ddp_ports[ ddp->ddp_lsat.sat_port - 1 ] != NULL ) {
-	if ( ddp->ddp_pprev != NULL ) {
-	    ddp->ddp_pprev->ddp_pnext = ddp->ddp_pnext;
-	} else {
-	    ddp_ports[ ddp->ddp_lsat.sat_port - 1 ] = ddp->ddp_pnext;
-	}
-	if ( ddp->ddp_pnext != NULL ) {
-	    ddp->ddp_pnext->ddp_pprev = ddp->ddp_pprev;
-	}
-    }
-
-    if ( ddp->ddp_route.ro_rt ) {
-	rtfree( ddp->ddp_route.ro_rt );
-    }
-
-    if ( ddp->ddp_prev ) {
-	ddp->ddp_prev->ddp_next = ddp->ddp_next;
-    } else {
-	ddpcb = ddp->ddp_next;
-    }
-    if ( ddp->ddp_next ) {
-	ddp->ddp_next->ddp_prev = ddp->ddp_prev;
-    }
-    FREE(ddp, M_PCB);
-}
-
-/*
- * For the moment, this just find the pcb with the correct local address.
- * In the future, this will actually do some real searching, so we can use
- * the sender's address to do de-multiplexing on a single port to many
- * sockets (pcbs).
- */
-struct ddpcb *
-ddp_search( struct sockaddr_at *from, struct sockaddr_at *to,
-			struct at_ifaddr *aa)
-{
-    struct ddpcb	*ddp;
-
-    /*
-     * Check for bad ports.
-     */
-    if ( to->sat_port < ATPORT_FIRST || to->sat_port >= ATPORT_LAST ) {
-	return( NULL );
-    }
-
-    /*
-     * Make sure the local address matches the sent address.  What about
-     * the interface?
-     */
-    for ( ddp = ddp_ports[ to->sat_port - 1 ]; ddp; ddp = ddp->ddp_pnext ) {
-	/* XXX should we handle 0.YY? */
-
-	/* XXXX.YY to socket on destination interface */
-	if ( to->sat_addr.s_net == ddp->ddp_lsat.sat_addr.s_net &&
-		to->sat_addr.s_node == ddp->ddp_lsat.sat_addr.s_node ) {
-	    break;
-	}
-
-	/* 0.255 to socket on receiving interface */
-	if ( to->sat_addr.s_node == ATADDR_BCAST && ( to->sat_addr.s_net == 0 ||
-		to->sat_addr.s_net == ddp->ddp_lsat.sat_addr.s_net ) &&
-		ddp->ddp_lsat.sat_addr.s_net == AA_SAT( aa )->sat_addr.s_net ) {
-	    break;
-	}
-
-	/* XXXX.0 to socket on destination interface */
-	if ( to->sat_addr.s_net == aa->aa_firstnet &&
-		to->sat_addr.s_node == 0 &&
-		ntohs( ddp->ddp_lsat.sat_addr.s_net ) >=
-		ntohs( aa->aa_firstnet ) &&
-		ntohs( ddp->ddp_lsat.sat_addr.s_net ) <=
-		ntohs( aa->aa_lastnet )) {
-	    break;
-	}
-    }
-    return( ddp );
-}
 static int
-at_setpeeraddr(struct socket *so, struct sockaddr **nam)
+at_getsockaddr(struct socket *so, struct sockaddr **nam)
 {
-	return(EOPNOTSUPP);
-}
-
-static int
-at_setsockaddr(struct socket *so, struct sockaddr **nam)
-{
 	struct ddpcb	*ddp;
 
-	ddp = sotoddpcb( so );
-	if ( ddp == NULL ) {
-	    return( EINVAL);
-	}
-	at_sockaddr( ddp, nam );
-	return(0);
-}
+	ddp = sotoddpcb(so);
+	KASSERT(ddp != NULL, ("at_getsockaddr: ddp == NULL"));
 
-
-void 
-ddp_init(void )
-{
-    atintrq1.ifq_maxlen = IFQ_MAXLEN;
-    atintrq2.ifq_maxlen = IFQ_MAXLEN;
+	DDP_LOCK(ddp);
+	at_sockaddr(ddp, nam);
+	DDP_UNLOCK(ddp);
+	return (0);
 }
 
-#if 0
-static void 
-ddp_clean(void )
-{
-    struct ddpcb	*ddp;
-
-    for ( ddp = ddpcb; ddp; ddp = ddp->ddp_next ) {
-	at_pcbdetach( ddp->ddp_socket, ddp );
-    }
-}
-#endif
-
 struct pr_usrreqs ddp_usrreqs = {
-	ddp_abort,
-	pru_accept_notsupp,
-	ddp_attach,
-	ddp_bind,
-	ddp_connect,
-	pru_connect2_notsupp,
-	at_control,
-	ddp_detach,
-	ddp_disconnect,
-	pru_listen_notsupp,
-	at_setpeeraddr,
-	pru_rcvd_notsupp,
-	pru_rcvoob_notsupp,
-	ddp_send,
-	pru_sense_null,
-	ddp_shutdown,
-	at_setsockaddr,
-	sosend,
-	soreceive,
-	sopoll
+	.pru_abort =		ddp_abort,
+	.pru_attach =		ddp_attach,
+	.pru_bind =		ddp_bind,
+	.pru_connect =		ddp_connect,
+	.pru_control =		at_control,
+	.pru_detach =		ddp_detach,
+	.pru_disconnect =	ddp_disconnect,
+	.pru_peeraddr =		at_getpeeraddr,
+	.pru_send =		ddp_send,
+	.pru_shutdown =		ddp_shutdown,
+	.pru_sockaddr =		at_getsockaddr,
+	.pru_close =		ddp_close,
 };
Index: at.h
===================================================================
--- at.h	(.../stable/4/sys/netatalk)	(revision 196046)
+++ at.h	(.../head/sys/netatalk)	(revision 196046)
@@ -1,4 +1,4 @@
-/*
+/*-
  * Copyright (c) 1990,1991 Regents of The University of Michigan.
  * All Rights Reserved.
  *
@@ -23,64 +23,64 @@
  * $FreeBSD$
  */
 
-#ifndef __AT_HEADER__
-#define __AT_HEADER__
+#ifndef _NETATALK_AT_H_
+#define	_NETATALK_AT_H_
+
 /*
  * Supported protocols
  */
-#define ATPROTO_DDP	0
-#define ATPROTO_AARP	254
+#define	ATPROTO_DDP	0
+#define	ATPROTO_AARP	254
 
-#define DDP_MAXSZ	587
+#define	DDP_MAXSZ	587
 
 /*
- * If ATPORT_FIRST <= Port < ATPORT_RESERVED,
- * Port was created by a privileged process.
- * If ATPORT_RESERVED <= Port < ATPORT_LAST,
- * Port was not necessarily created by a
+ * If ATPORT_FIRST <= Port < ATPORT_RESERVED, the port was created by a
  * privileged process.
+ *
+ * If ATPORT_RESERVED <= Port < ATPORT_LAST, the port was not necessarily
+ * created by a privileged process.
  */
-#define ATPORT_FIRST	1
-#define ATPORT_RESERVED	128
-#define ATPORT_LAST	255
+#define	ATPORT_FIRST	1
+#define	ATPORT_RESERVED	128
+#define	ATPORT_LAST	255
 
 /*
  * AppleTalk address.
  */
 struct at_addr {
-    u_short	s_net;
-    u_char	s_node;
+	u_short	s_net;
+	u_char	s_node;
 };
 
-#define ATADDR_ANYNET	(u_short)0x0000
-#define ATADDR_ANYNODE	(u_char)0x00
-#define ATADDR_ANYPORT	(u_char)0x00
-#define ATADDR_BCAST	(u_char)0xff		/* There is no BCAST for NET */
+#define	ATADDR_ANYNET	(u_short)0x0000
+#define	ATADDR_ANYNODE	(u_char)0x00
+#define	ATADDR_ANYPORT	(u_char)0x00
+#define	ATADDR_BCAST	(u_char)0xff	/* There is no BCAST for NET. */
 
 struct netrange {
-    u_char		nr_phase;
-    u_short		nr_firstnet;
-    u_short		nr_lastnet;
+	u_char	nr_phase;
+	u_short	nr_firstnet;
+	u_short	nr_lastnet;
 };
 
 /*
- * Socket address, AppleTalk style.  We keep magic information in the 
- * zero bytes.  There are three types, NONE, CONFIG which has the phase
- * and a net range, and IFACE which has the network address of an
- * interface.  IFACE may be filled in by the client, and is filled in
- * by the kernel.
+ * Socket address, AppleTalk style.  We keep magic information in the zero
+ * bytes.  There are three types, NONE, CONFIG which has the phase and a net
+ * range, and IFACE which has the network address of an interface.  IFACE may
+ * be filled in by the client, and is filled in by the kernel.
  */
 struct sockaddr_at {
-    u_char		sat_len;
-    u_char		sat_family;
-    u_char		sat_port;
-    struct at_addr	sat_addr;
-    union {
-	struct netrange r_netrange;
-    	char		r_zero[ 8 ];	/* Hide a struct netrange in here */
-    } sat_range;
+	u_char		sat_len;
+	u_char		sat_family;
+	u_char		sat_port;
+	struct at_addr	sat_addr;
+	union {
+		struct netrange	r_netrange;
+		char		r_zero[8];	/* Hide struct netrange here. */
+	} sat_range;
 };
 
-#define sat_zero sat_range.r_zero
+#define	sat_zero	sat_range.r_zero
 
-#endif /* !__AT_HEADER__ */
+#endif /* !_NETATALK_AT_H_ */
Index: ddp.h
===================================================================
--- ddp.h	(.../stable/4/sys/netatalk)	(revision 196046)
+++ ddp.h	(.../head/sys/netatalk)	(revision 196046)
@@ -1,5 +1,5 @@
-/*
- * Copyright (c) 1990,1991 Regents of The University of Michigan.
+/*-
+ * Copyright (c) 1990, 1991 Regents of The University of Michigan.
  * All Rights Reserved.
  *
  * Permission to use, copy, modify, and distribute this software and
@@ -19,11 +19,14 @@
  *	Ann Arbor, Michigan
  *	+1-313-763-0525
  *	netatalk@itd.umich.edu
+ *
+ * $FreeBSD$
  */
+
 #ifndef _NETATALK_DDP_H_
-#define _NETATALK_DDP_H_ 1
+#define	_NETATALK_DDP_H_
 
-/*
+/*-
  * <-1byte(8bits) ->
  * +---------------+
  * | 0 | hopc  |len|
@@ -51,83 +54,84 @@
  * | Src PORT      |
  * +---------------+
  *
- * On Apples, there is also a ddp_type field, after src_port. However,
- * under this unix implementation, user level processes need to be able
- * to set the ddp_type. In later revisions, the ddp_type may only be
- * available in a raw_appletalk interface.
+ * On Apples, there is also a ddp_type field, after src_port.  However, under
+ * this unix implementation, user level processes need to be able to set the
+ * ddp_type.  In later revisions, the ddp_type may only be available in a
+ * raw_appletalk interface.
  */
 
 struct elaphdr {
-    u_char	el_dnode;
-    u_char	el_snode;
-    u_char	el_type;
-};
+	u_char	el_dnode;
+	u_char	el_snode;
+	u_char	el_type;
+} __packed;
 
 #define	SZ_ELAPHDR	3
 
-#define ELAP_DDPSHORT	0x01
-#define ELAP_DDPEXTEND	0x02
+#define	ELAP_DDPSHORT	0x01
+#define	ELAP_DDPEXTEND	0x02
 
 /*
  * Extended DDP header. Includes sickness for dealing with arbitrary
  * bitfields on a little-endian arch.
  */
 struct ddpehdr {
-    union {
-	struct {
+	union {
+		struct {
 #if BYTE_ORDER == BIG_ENDIAN
-    unsigned		dub_pad:2;
-    unsigned		dub_hops:4;
-    unsigned		dub_len:10;
-    unsigned		dub_sum:16;
+			unsigned	dub_pad:2;
+			unsigned	dub_hops:4;
+			unsigned	dub_len:10;
+			unsigned	dub_sum:16;
 #endif
 #if BYTE_ORDER == LITTLE_ENDIAN
-    unsigned		dub_sum:16;
-    unsigned		dub_len:10;
-    unsigned		dub_hops:4;
-    unsigned		dub_pad:2;
+			unsigned	dub_sum:16;
+			unsigned	dub_len:10;
+			unsigned	dub_hops:4;
+			unsigned	dub_pad:2;
 #endif
-	} du_bits;
-	unsigned	du_bytes;
-    } deh_u;
-#define deh_pad		deh_u.du_bits.dub_pad
-#define deh_hops	deh_u.du_bits.dub_hops
-#define deh_len		deh_u.du_bits.dub_len
-#define deh_sum		deh_u.du_bits.dub_sum
-#define deh_bytes	deh_u.du_bytes
-    u_short		deh_dnet;
-    u_short		deh_snet;
-    u_char		deh_dnode;
-    u_char		deh_snode;
-    u_char		deh_dport;
-    u_char		deh_sport;
-};
+		} __packed du_bits;
+		unsigned	du_bytes;
+	} deh_u;
+	u_short	deh_dnet;
+	u_short	deh_snet;
+	u_char	deh_dnode;
+	u_char	deh_snode;
+	u_char	deh_dport;
+	u_char	deh_sport;
+} __packed;
+#define	deh_pad		deh_u.du_bits.dub_pad
+#define	deh_hops	deh_u.du_bits.dub_hops
+#define	deh_len		deh_u.du_bits.dub_len
+#define	deh_sum		deh_u.du_bits.dub_sum
+#define	deh_bytes	deh_u.du_bytes
 
-#define DDP_MAXHOPS	15
+#define	DDP_MAXHOPS	15
 
 struct ddpshdr {
-    union {
-	struct {
+	union {
+		struct {
 #if BYTE_ORDER == BIG_ENDIAN
-    unsigned		dub_pad:6;
-    unsigned		dub_len:10;
-    unsigned		dub_dport:8;
-    unsigned		dub_sport:8;
+			unsigned	dub_pad:6;
+			unsigned	dub_len:10;
+			unsigned	dub_dport:8;
+			unsigned	dub_sport:8;
 #endif
 #if BYTE_ORDER == LITTLE_ENDIAN
-    unsigned		dub_sport:8;
-    unsigned		dub_dport:8;
-    unsigned		dub_len:10;
-    unsigned		dub_pad:6;
+			unsigned	dub_sport:8;
+			unsigned	dub_dport:8;
+			unsigned	dub_len:10;
+			unsigned	dub_pad:6;
 #endif
-	} du_bits;
-	unsigned	du_bytes;
-    } dsh_u;
-#define dsh_pad		dsh_u.du_bits.dub_pad
-#define dsh_len		dsh_u.du_bits.dub_len
-#define dsh_dport	dsh_u.du_bits.dub_dport
-#define dsh_sport	dsh_u.du_bits.dub_sport
-#define dsh_bytes	dsh_u.du_bytes
-};
+		} __packed du_bits;
+		unsigned	du_bytes;
+	} dsh_u;
+} __packed;
 
+#define	dsh_pad		dsh_u.du_bits.dub_pad
+#define	dsh_len		dsh_u.du_bits.dub_len
+#define	dsh_dport	dsh_u.du_bits.dub_dport
+#define	dsh_sport	dsh_u.du_bits.dub_sport
+#define	dsh_bytes	dsh_u.du_bytes
+
 #endif /* _NETATALK_DDP_H_ */
Index: at_var.h
===================================================================
--- at_var.h	(.../stable/4/sys/netatalk)	(revision 196046)
+++ at_var.h	(.../head/sys/netatalk)	(revision 196046)
@@ -1,5 +1,5 @@
-/*
- * Copyright (c) 1990,1991 Regents of The University of Michigan.
+/*-
+ * Copyright (c) 1990, 1991 Regents of The University of Michigan.
  * All Rights Reserved.
  *
  * Permission to use, copy, modify, and distribute this software and
@@ -24,44 +24,54 @@
  */
 
 #ifndef _NETATALK_AT_VAR_H_
-#define _NETATALK_AT_VAR_H_ 1
+#define	_NETATALK_AT_VAR_H_
+
 /*
- * For phase2, we need to keep not only our address on an interface,
- * but also the legal networks on the interface.
+ * For phase2, we need to keep not only our address on an interface, but also
+ * the legal networks on the interface.
  */
 struct at_ifaddr {
-    struct ifaddr	  aa_ifa;
-# define aa_ifp			aa_ifa.ifa_ifp
-    struct sockaddr_at	  aa_addr;
-    struct sockaddr_at	  aa_broadaddr;
-# define aa_dstaddr		aa_broadaddr;
-    struct sockaddr_at	  aa_netmask;
-    int			  aa_flags;
-    u_short		  aa_firstnet, aa_lastnet;
-    int			  aa_probcnt;
-    struct callout_handle aa_ch;
-    struct at_ifaddr	  *aa_next;
+	struct ifaddr		 aa_ifa;
+	struct sockaddr_at	 aa_addr;
+	struct sockaddr_at	 aa_broadaddr;
+	struct sockaddr_at	 aa_netmask;
+	int			 aa_flags;
+	u_short			 aa_firstnet;
+	u_short			 aa_lastnet;
+	int			 aa_probcnt;
+	struct callout		 aa_callout;
+	TAILQ_ENTRY(at_ifaddr)	 aa_link;
 };
+#define	aa_ifp		aa_ifa.ifa_ifp
+#define	aa_dstaddr	aa_broadaddr;
 
+TAILQ_HEAD(at_ifaddrhead, at_ifaddr);
+
 struct at_aliasreq {
-	char	ifra_name[IFNAMSIZ];		/* if name, e.g. "en0" */
-	struct	sockaddr_at ifra_addr;
-	struct	sockaddr_at ifra_broadaddr;
-#define ifra_dstaddr ifra_broadaddr
-	struct	sockaddr_at ifra_mask;
+	char			ifra_name[IFNAMSIZ];
+	struct sockaddr_at	ifra_addr;
+	struct sockaddr_at	ifra_broadaddr;
+	struct sockaddr_at	ifra_mask;
 };
+#define	ifra_dstaddr	ifra_broadaddr
 
-#define AA_SAT(aa) \
-    (&(aa->aa_addr))
-#define satosat(sa)	((struct sockaddr_at *)(sa))
+#define	AA_SAT(aa)	(&(aa->aa_addr))
+#define	satosat(sa)	((struct sockaddr_at *)(sa))
 
-#define AFA_ROUTE	0x0001
-#define AFA_PROBING	0x0002
-#define AFA_PHASE2	0x0004
+#define	AFA_ROUTE	0x0001
+#define	AFA_PROBING	0x0002
+#define	AFA_PHASE2	0x0004
 
 #ifdef _KERNEL
-extern struct at_ifaddr	*at_ifaddr;
-extern struct ifqueue	atintrq1, atintrq2;
+extern struct rwlock		at_ifaddr_rw;
+extern struct at_ifaddrhead	at_ifaddrhead;
+
+#define	AT_IFADDR_LOCK_INIT()	rw_init(&at_ifaddr_rw, "at_ifaddr_rw")
+#define	AT_IFADDR_LOCK_ASSERT()	rw_assert(&at_ifaddr_rw, RA_LOCKED)
+#define	AT_IFADDR_RLOCK()	rw_rlock(&at_ifaddr_rw)
+#define	AT_IFADDR_RUNLOCK()	rw_runlock(&at_ifaddr_rw)
+#define	AT_IFADDR_WLOCK()	rw_wlock(&at_ifaddr_rw)
+#define	AT_IFADDR_WUNLOCK()	rw_wunlock(&at_ifaddr_rw)
 #endif
 
 #endif /* _NETATALK_AT_VAR_H_ */
